import java.awt.*;
import java.io.*;
import java.net.*;
import javax.swing.*;
import java.util.*;
import java.awt.event.*;
public class OpenLevelXarrow3D2Applet extends JApplet implements Runnable,ActionListener,KeyListener{
    JLabel la;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Thread t;
    JButton b;
    boolean startb=false;
    JPanel p;
    Xarrow3D2 game1;
    Xarrow3D2 game2;
    String statusp1="";
    String statusp2="";
    static OpenLevelXarrow3D2Applet app;
    KeyboardMapperAppletSwing km=null;
    private static final long serialVersionUID = -5218961132597673708L;
    public void init(){
//        super("Xarrow3D2 Open Level");
//        pack();
        app=this;
        setSize(800,520);
        setLayout(null);
        la=new JLabel("ESC, player 1: cursor keys, delete player 2: s, y, x, c, a");
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("open");
        p=new JPanel();
        add(la);
        la.setBounds(10,40,380,27);
        p.setLayout(null);
        p.add(spl);
        p.add(b);
        add(p);
        p.setBounds(0,80,400,400);
        p.setVisible(true);
        spl.setBounds(10,40,380,300);
        b.setBounds(10,350,380,27);
        setVisible(true);
        b.addActionListener(this);
        addKeyListener(this);
        requestFocus();
        loadlevs();
        t=new Thread(this);
        t.start();
    }
    public void run(){
        p.setVisible(false);
        km=new KeyboardMapperAppletSwing(this);
        add(km);
        km.setBounds(0,70,400,400);
        km.setVisible(true);
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        p.setVisible(true);
        while(true){
            try{
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        String levstring=lcontent.elementAt(ind);
                        p.setVisible(false);
                        game1=new Xarrow3D2(this,levstring,false);
                        game2=new Xarrow3D2(this,levstring,true);
                        add(game1);
                        add(game2);
                        game1.setBounds(0,80,400,400);
                        game2.setBounds(400,80,400,400);
                        statusp1="";
                        statusp2="";
                        requestFocus();
                    }
                }
                if(game1!=null&&game2!=null){
                    la.setText(""+statusp1+""+statusp2);
                }
            }
            catch(Exception e){
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==b){
            startb=true;
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        int key=e.getKeyCode();
        if(km!=null&&km.applyb){
            key=km.getKeyCode(key);
        }
//System.out.println("key: "+key);
        if(key>0){
            process(key);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void process(int key){
        if(game1!=null){
            if(key==KeyEvent.VK_ESCAPE||key==27){
                game1.running=false;
                game2.running=false;
                remove(game1);
                remove(game2);
                game1=null;
                game2=null;
                p.setVisible(true);
            }
            if(key==KeyEvent.VK_DOWN||key==KeyEvent.VK_UP||key==KeyEvent.VK_LEFT||key==KeyEvent.VK_RIGHT||key==KeyEvent.VK_DELETE){
                game1.keycode=key;
            }
        }
        if(game2!=null){
            if(key==88||key==83||key==67||key==89||key==65){
                game2.keycode=key;
            }
        }
    }
    public void process2(int key){
        if(game1!=null){
            if(key==KeyEvent.VK_DOWN){
                if(game1.startd){
                    game1.xdrift=0;
                    game1.ydrift=5;
                    game1.startd=false;
                }
                else{
                    game1.edown=true;
                }
            }
            if(key==KeyEvent.VK_UP){
                if(game1.startd){
                    game1.xdrift=0;
                    game1.ydrift=-5;
                    game1.startd=false;
                }
                else{
                    game1.eup=true;
                }
            }
            if(key==KeyEvent.VK_RIGHT){
                if(game1.startd){
                    game1.xdrift=5;
                    game1.ydrift=0;
                    game1.startd=false;
                }
                else{
                    game1.eright=true;
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(game1.startd){
                    game1.xdrift=-5;
                    game1.ydrift=0;
                    game1.startd=false;
                }
                else{
                    game1.eleft=true;
                }
            }
            if(key==KeyEvent.VK_DELETE){
                game1.edelete=true;
            }
        }
        if(game2!=null){
            if(key==88){
                if(game2.startd){
                    game2.xdrift=0;
                    game2.ydrift=5;
                    game2.startd=false;
                }
                else{
                    game2.edown=true;
                }
            }
            if(key==83){
                if(game2.startd){
                    game2.xdrift=0;
                    game2.ydrift=-5;
                    game2.startd=false;
                }
                else{
                    game2.eup=true;
                }
            }
            if(key==67){
                if(game2.startd){
                    game2.xdrift=5;
                    game2.ydrift=0;
                    game2.startd=false;
                }
                else{
                    game2.eright=true;
                }
            }
            if(key==89){
                if(game2.startd){
                    game2.xdrift=-5;
                    game2.ydrift=0;
                    game2.startd=false;
                }
                else{
                    game2.eleft=true;
                }
            }
            if(key==65){
                game2.edelete=true;
            }
        }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
//            FileInputStream fis=new FileInputStream(filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public void loadlevs(){
        try{
            InputStream is=OpenLevelXarrow3D2Applet.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            is.close();
            l.setListData(lcontent);
        }
        catch(Exception e){};
    }
    public static void main(String[]args){
        new OpenLevelXarrow3D2Applet();
    }
}
class Xarrow3D2 extends JPanel implements Runnable{
    Thread t;
    int xpos=0;
    int ypos=0;
    int xdrift=0;
    int ydrift=0;
    String name;
    int[][]screen;
    Group[][]groupscreen;
    Group[][]groupscreenb;
    Group player;
    int width=0;
    int height=0;
    int lifes=3;
    int points=0;
    int treasures=0;
    int xstart=0;
    int ystart=0;
    boolean wall=true;
    boolean inverse=false;
    boolean moveplayer=true;
    double alpha=Math.PI/2;
    double beta=Math.PI/4;
    Vektor camerapos;
    Vektor cameraposplus;
    EngineXarrow3D2 eng;
    OpenLevelXarrow3D2Applet ol;
    boolean endfirst=true;
    boolean running=true;
    Color pcolor;
    Color pcolor2;
    int turbo=0;
    int drive=0;
    int direction=0;
    int turbob=0;
    int driveb=0;
    int directionb=0;
    int phase=4;
    boolean all=false;
    boolean seldir=false;
    boolean eup=false;
    boolean edown=false;
    boolean eleft=false;
    boolean eright=false;
    boolean edelete=false;
    boolean startd=true;
    int ax=0;
    int ay=0;
    int xw=0;
    int yw=0;
    boolean player2=false;
    int keycode=0;
    private static final long serialVersionUID = 4026763353595498853L;
    public Xarrow3D2(OpenLevelXarrow3D2Applet ol,String name,boolean player2){
//        super("Astro Solutions Xarrow3D2");
        setSize(400,400);
        setLayout(null);
        this.ol=ol;
        this.player2=player2;
        pcolor=new Color(255,255,0);
        pcolor2=new Color(255,0,0);
        eng=new EngineXarrow3D2();
        eng.setStatus("");
        add(eng);
        eng.setBounds(0,0,400,400);
        setVisible(true);
        this.name=name;
        screen=new int[30][18];
        groupscreen=new Group[30][18];
        groupscreenb=new Group[30][18];
        player=ObjectGenerator.getKugel();
        loadScreen();
        build();
        t=new Thread(this);
        t.start();
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public void loadScreen(){
        try{
//            FileInputStream is=new FileInputStream(name);
            InputStream is=OpenLevelXarrow3D2Applet.getInputStream(name);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
//System.out.println("i: "+i+" j: "+j+" screen: "+screen[i][j]);
                    if(screen[i][j]==12){
                        treasures++;
                    }
                    if(screen[i][j]==13){
                        xpos=i*50;
                        ypos=j*50;
                        xstart=xpos;
                        ystart=ypos;
                        camerapos=new Vektor(xpos+25,ypos+25,300);
                        cameraposplus=new Vektor(-Math.cos(alpha)*300,-Math.sin(alpha)*300,0);
                        player.transform(xpos,ypos,0);
                        eng.add(player);
                        screen[i][j]=0;
                    }
                }
            }
        }
        catch(Exception e){
        }
    }
    public void run(){
        int gc=0;
        while(running){
//            try{
//System.out.println("xxx"+Runtime.getRuntime().freeMemory());
                if(keycode!=0){
                    ol.process2(keycode);
                }
                keycode=0;
                action();
                step();
//System.out.println("yyy");
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
//System.out.println("yyy");
                cameraposplus.x=Math.cos(alpha)*300;
                cameraposplus.y=Math.sin(alpha)*300;
                double xtrans=camerapos.x+cameraposplus.x;
                double ytrans=camerapos.y+cameraposplus.y;
                double ztrans=camerapos.z+cameraposplus.z;
                double alphab=alpha;
                double betab=beta;
//                setWallOn();
//System.out.println("transform");
                eng.transform(-xtrans,-ytrans,-ztrans);
//System.out.println("xtrans: "+xtrans);
//System.out.println("ytrans: "+ytrans);
//System.out.println("ztrans: "+ztrans);
//System.out.println("alphab: "+alphab);
//System.out.println("betab: "+betab);
                alphab=alphab+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                eng.rotLeft(-alphab);
                eng.rotUp(betab);
//System.out.println("gs: "+groupscreen[0][0].start.start.x);
                eng.setOn();
                eng.move();
                eng.repaint();
//                eng.setOff();
                eng.rotUp(-betab);
                eng.rotLeft(alphab);
                eng.transform(xtrans,ytrans,ztrans);
//                setWallOff();
try{
                Thread.sleep(80);
}
catch(Exception e){
}
//            }
//            catch(Exception e){
//                System.out.println("e: "+e);
//                try{
//                    Thread.sleep(10000);
//                }
//                catch(Exception eb){
//                };
//            }
        }
    }
    public static void main(String[]args){
        new OpenLevelXarrow3D2Applet();
    }
    public void action(){
            if(edown){
                edown=false;
                if(moveplayer){
//System.out.println("a");
                    if(!seldir){
                        keyPressed(-4);
                    }
                    else{
                        xdrift=0;
                        ydrift=5;
                    }
                }
                else{
//System.out.println("b");
                    if(!inverse&&beta+Math.PI/90<=Math.PI/2){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else if(beta-Math.PI/90>=-Math.PI/2){
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(eup){
                eup=false;
                if(moveplayer){
                    if(!seldir){
                        keyPressed(-3);
                    }
                    else{
                        xdrift=0;
                        ydrift=-5;
                    }
                }
                else{
                    if(inverse&&beta+Math.PI/90<=Math.PI/2){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else if(beta-Math.PI/90>=-Math.PI/2){
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(eright){
                eright=false;
                if(moveplayer){
                   if(!seldir){
                       keyPressed(-1);
                   }
                   else{
                       xdrift=5;
                       ydrift=0;
                   }
                }
                else{
                    alpha=alpha-Math.PI/90;
                    if(alpha<0){
                        alpha=alpha+2*Math.PI;
                    }
                }
            }
            if(eleft){
                eleft=false;
                if(moveplayer){
                    if(!seldir){
                        keyPressed(-2);
                    }
                    else{
                        xdrift=-5;
                        ydrift=0;
                    }
                }
                else{
                    alpha=alpha+Math.PI/90;
                    if(alpha>2*Math.PI){
                        alpha=alpha-2*Math.PI;
                    }
                }
            }
            if(edelete){
                edelete=false;
                if(moveplayer){
                    moveplayer=false;
                }
                else{
                    moveplayer=true;
                }
            }

    }
    public void keyPressed(int keycode){
        if(keycode==-1){
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(screen[i][j]>=1&&screen[i][j]<=4){
                        groupscreen[i][j].transform(-i*50-25,-j*50-25,0);
                        groupscreen[i][j].rotLeft(Math.PI/2);
                        groupscreen[i][j].transform(i*50+25,j*50+25,0);
                        screen[i][j]=screen[i][j]-1;
                        if(screen[i][j]==0){
                            screen[i][j]=4;
                        }
                    }
                }
            }
        }
        if(keycode==-2){
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(screen[i][j]>=1&&screen[i][j]<=4){
                        groupscreen[i][j].transform(-i*50-25,-j*50-25,0);
                        groupscreen[i][j].rotLeft(-Math.PI/2);
                        groupscreen[i][j].transform(i*50+25,j*50+25,0);
                        screen[i][j]=screen[i][j]+1;
                        if(screen[i][j]==5){
                            screen[i][j]=1;
                        }
                    }
                }
            }
        }
        if(keycode==-3||keycode==-4){
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(screen[i][j]>=8&&screen[i][j]<=10){
                        eng.remove(groupscreen[i][j]);
                        if(groupscreenb[i][j]!=null){
                            eng.remove(groupscreenb[i][j]);
                            groupscreenb[i][j]=null;
                        }
                        if(keycode==-3){
                            screen[i][j]=screen[i][j]+1;
                            if(screen[i][j]==11){
                                screen[i][j]=8;
                            }
                        }
                        else{
                            screen[i][j]=screen[i][j]-1;
                            if(screen[i][j]==7){
                                screen[i][j]=10;
                            }
                        }
                        if(screen[i][j]==8){
                            groupscreen[i][j]=ObjectGenerator.getLochz();
                            groupscreen[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreen[i][j]);
                        }
                        if(screen[i][j]==9){
                            groupscreen[i][j]=ObjectGenerator.getBodenz();
                            groupscreen[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreen[i][j]);
                        }
                        if(screen[i][j]==10){
                            groupscreen[i][j]=ObjectGenerator.getSteinz();
                            groupscreen[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreen[i][j]);
                            groupscreenb[i][j]=ObjectGenerator.getBoden();
                            groupscreenb[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreenb[i][j]);
                        }


                    }
                }
            }
        }
    }
    public void keyPressedb(int keycode){
        if(keycode==-3){
            double axpos=xpos;
            if(xpos==0){
                xpos=xpos-50;
            }
            if(xpos-50>=0&&screen[(xpos-50)/50][ypos/50]!=1&&screen[(xpos-50)/50][ypos/50]!=2){
                xpos=xpos-50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-4){
            double axpos=xpos;
            if(xpos==1450){
                xpos=xpos+50;
            }
            if(xpos+50<1500&&screen[(xpos+50)/50][ypos/50]!=1&&screen[(xpos+50)/50][ypos/50]!=2){
                xpos=xpos+50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-2){
            double aypos=ypos;
            if(ypos==850){
                ypos=ypos+50;
            }
            if(ypos+50<900&&screen[xpos/50][(ypos+50)/50]!=1&&screen[xpos/50][(ypos+50)/50]!=2){
                ypos=ypos+50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-1){
            double aypos=ypos;
            if(ypos==0){
                ypos=ypos-50;
            }
            if(ypos-50>=0&&screen[xpos/50][(ypos-50)/50]!=1&&screen[xpos/50][(ypos-50)/50]!=2){
                ypos=ypos-50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-5){
//            newbomb(xpos/50,ypos/50,true);
        }
        if(keycode==-8){
//            Loader mov=new Loader(m,"game stopped");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
    }
    public void build(){
        for(int i=0;i<32;i++){
            Group rand=ObjectGenerator.getHardStone();
            rand.transform(i*50-50,-50,0);
            eng.add(rand);
            Group randx=ObjectGenerator.getBoden();
            randx.transform(i*50-50,-50,0);
            eng.add(randx);
            Group rand2=ObjectGenerator.getHardStone();
            rand2.transform(i*50-50,900,0);
            eng.add(rand2);
            Group randx2=ObjectGenerator.getBoden();
            randx2.transform(i*50-50,900,0);
            eng.add(randx2);
        }
        for(int i=0;i<18;i++){
            Group rand=ObjectGenerator.getHardStone();
            rand.transform(-50,i*50,0);
            eng.add(rand);
            Group randx=ObjectGenerator.getBoden();
            randx.transform(-50,i*50,0);
            eng.add(randx);
            Group rand2=ObjectGenerator.getHardStone();
            rand2.transform(1500,i*50,0);
            eng.add(rand2);
            Group randx2=ObjectGenerator.getBoden();
            randx2.transform(1500,i*50,0);
            eng.add(randx2);
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                int x=i;
                int y=j;
                if(x>=0&&y>=0&&x<30&&y<18){
//System.out.println("xp:"+xp+"i:"+i);
                    if(screen[x][y]==0||screen[x][y]==6||screen[x][y]==13){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]>=1&&screen[x][y]<=4){
                        groupscreen[x][y]=ObjectGenerator.getArrow();
                        groupscreen[x][y].transform(-25,-25,0);
                        groupscreen[x][y].rotLeft(-(screen[x][y]-2)*Math.PI/2);
                        groupscreen[x][y].transform(i*50+25,j*50+25,0);
//                        Group groupscreenc=ObjectGenerator.getBoden();
//                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
//                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==5){
                        groupscreen[x][y]=ObjectGenerator.getLoch();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==7){
                        groupscreen[x][y]=ObjectGenerator.getStein();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==8){
                        groupscreen[x][y]=ObjectGenerator.getLochz();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==9){
                        groupscreen[x][y]=ObjectGenerator.getBodenz();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==10){
                        groupscreen[x][y]=ObjectGenerator.getSteinz();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        groupscreenb[x][y]=ObjectGenerator.getBoden();
                        groupscreenb[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreenb[x][y]);
                    }
                    if(screen[x][y]==11){
                        groupscreen[x][y]=ObjectGenerator.getZufall();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==12){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getFahne();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==14){
//                        Group groupscreenc=ObjectGenerator.getBoden();
//                        groupscreenc.transform(i*50,j*50,0);
//                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getWahl();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]>=15&&screen[x][y]<=18){
//                        Group groupscreenc=ObjectGenerator.getBoden();
//                        groupscreenc.transform(i*50,j*50,-20);
//                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getFestArrow();
                        groupscreen[x][y].transform(-25,-25,0);
                        groupscreen[x][y].rotLeft(-(screen[x][y]-16)*Math.PI/2);
                        groupscreen[x][y].transform(i*50+25,j*50+25,0);
                        eng.add(groupscreen[x][y]);
                    }
                }
            }
        }
    }
    public void step(){
        xpos=xpos+xdrift;
        ypos=ypos+ydrift;
        player.transform(xdrift,ydrift,0);
        camerapos.x=xpos;
        camerapos.y=ypos;
//System.out.println("hallo2");
        boolean loso=false;
        int xposb=(xpos+25)/50;
        int yposb=(ypos+25)/50;
        if(xposb>=0&&xposb<30&&yposb>=0&&yposb<18){
            if(screen[xposb][yposb]==12){
                screen[xposb][yposb]=0;
                treasures--;
                if(!player2){
                    ol.statusp1="player 1 must collect: "+treasures+" ";
                }
                else{
                    ol.statusp2="player 2 must collect: "+treasures+" ";
                }
                eng.remove(groupscreen[xposb][yposb]);
            }
            if(screen[xposb][yposb]==7||screen[xposb][yposb]==10){
                ydrift=-ydrift;
                xdrift=-xdrift;
            }
            if(screen[xposb][yposb]==5){
                loso=true;
            }
            if(screen[xposb][yposb]==8){
                loso=true;
            }
            if(screen[xposb][yposb]==11){
                xdrift=(int)(Math.random()*20)-10;
                ydrift=(int)(Math.random()*20)-10;
            }
            if(screen[xposb][yposb]==1||screen[xposb][yposb]==15){
                xdrift=-5;
                ydrift=0;
            }
            if(screen[xposb][yposb]==2||screen[xposb][yposb]==16){
                xdrift=0;
                ydrift=5;
            }
            if(screen[xposb][yposb]==3||screen[xposb][yposb]==17){
                xdrift=5;
                ydrift=0;
            }
            if(screen[xposb][yposb]==4||screen[xposb][yposb]==18){
                xdrift=0;
                ydrift=-5;
            }
            if(screen[xposb][yposb]==14){
                seldir=true;
            }
            else{
                seldir=false;
            }
        }
//System.out.println("hallo3");
//System.out.println("hallo4");
        if(xpos<0||xpos>=1500){
            xdrift=-xdrift;
        }
        if(ypos<-25||ypos>=900-25){
            ydrift=-ydrift;
        }
        if(treasures==0){
//            setTitle("You won!");
            if(endfirst){
                endfirst=false;
                if(!player2){
                    ol.statusp1="player 1 completed level. ";
                }
                else{
                    ol.statusp2="player 2 completed level. ";
                }
                running=false;
//                ol.show();
            }
//            eng.setStatus("You won!");
//            Loader mov=new Loader(m,"You won!");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
        if(loso){
            lifes--;
            if(lifes<=0){
//                setTitle("You lost!");
                running=false;
                if(endfirst){
                    endfirst=false;
                    if(!player2){
                        ol.statusp1="player 1 lost (lifes=0). ";
                    }
                    else{
                        ol.statusp2="player 2 lost (lifes=0). ";
                    }
//                    ol.show();
                }
//                eng.setStatus("You lost!");
//                Loader mov=new Loader(m,"You lost!");
//                Display d=Display.getDisplay(m);
//                d.setCurrent((Displayable)mov);
            }
            else{
                player.transform(xstart-xpos,ystart-ypos,0);
                if(!player2){
                    ol.statusp1="player 1 lifes: "+lifes+" ";
                }
                else{
                    ol.statusp2="player 2 lifes: "+lifes+" ";
                }
                xpos=xstart;
                ypos=ystart;
                xdrift=0;
                ydrift=0;
                startd=true;
            }
        }
//System.out.println("b");
//        h.drawImage(you,width/2+100,height/2+100,0);
//        g.drawImage(img,-100,-100,0);
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.darkGray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.lightGray,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getArrow(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.green,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(20,5,0);
        Vektor v6=new Vektor(20,25,0);
        Vektor v7=new Vektor(5,25,0);
        Vektor v8=new Vektor(25,45,0);
        Vektor v9=new Vektor(45,25,0);
        Vektor v10=new Vektor(30,25,0);
        Vektor v11=new Vektor(30,5,0);
        Polygon p=new Polygon(Color.red,Color.black);
        p.add(v5);
        p.add(v6);
        p.add(v7);
        p.add(v8);
        p.add(v9);
        p.add(v10);
        p.add(v11);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        p.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(p);
        return g;
    }
    public static Group getLoch(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.black,Color.black,v1,v2,v3,v4);
        Group g=new Group();
        g.add(q1);
        return g;
    }
    public static Group getStein(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(45,5,0);
        Vektor v3=new Vektor(45,45,0);
        Vektor v4=new Vektor(5,45,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,30);
        Vektor v6=new Vektor(45,5,30);
        Vektor v7=new Vektor(45,45,30);
        Vektor v8=new Vektor(5,45,30);
        Quad q2=new Quad(Color.blue,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,30);
        Vektor v10=new Vektor(45,5,30);
        Vektor v11=new Vektor(45,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,45,30);
        Vektor v14=new Vektor(45,45,30);
        Vektor v15=new Vektor(45,45,0);
        Vektor v16=new Vektor(5,45,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,30);
        Vektor v18=new Vektor(5,45,30);
        Vektor v19=new Vektor(5,45,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,30);
        Vektor v22=new Vektor(45,45,30);
        Vektor v23=new Vektor(45,45,0);
        Vektor v24=new Vektor(45,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,30);
        Vektor v26=new Vektor(40,10,30);
        Vektor v27=new Vektor(40,40,30);
        Vektor v28=new Vektor(10,40,30);
        Quad q7=new Quad(Color.orange,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getLochz(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.black,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getBodenz(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.lightGray,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getSteinz(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(45,5,0);
        Vektor v3=new Vektor(45,45,0);
        Vektor v4=new Vektor(5,45,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,30);
        Vektor v6=new Vektor(45,5,30);
        Vektor v7=new Vektor(45,45,30);
        Vektor v8=new Vektor(5,45,30);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,30);
        Vektor v10=new Vektor(45,5,30);
        Vektor v11=new Vektor(45,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,45,30);
        Vektor v14=new Vektor(45,45,30);
        Vektor v15=new Vektor(45,45,0);
        Vektor v16=new Vektor(5,45,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,30);
        Vektor v18=new Vektor(5,45,30);
        Vektor v19=new Vektor(5,45,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,30);
        Vektor v22=new Vektor(45,45,30);
        Vektor v23=new Vektor(45,45,0);
        Vektor v24=new Vektor(45,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,30);
        Vektor v26=new Vektor(40,10,30);
        Vektor v27=new Vektor(40,40,30);
        Vektor v28=new Vektor(10,40,30);
        Quad q7=new Quad(Color.yellow,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getZufall(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,5);
        Vektor v6=new Vektor(45,5,5);
        Vektor v7=new Vektor(45,45,5);
        Vektor v8=new Vektor(5,45,5);
        Quad q2=new Quad(Color.red,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(10,10,10);
        Vektor v10=new Vektor(40,10,10);
        Vektor v11=new Vektor(40,40,10);
        Vektor v12=new Vektor(10,40,10);
        Quad q3=new Quad(Color.yellow,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(15,15,15);
        Vektor v14=new Vektor(35,15,15);
        Vektor v15=new Vektor(35,35,15);
        Vektor v16=new Vektor(15,35,15);
        Quad q4=new Quad(Color.green,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(20,20,20);
        Vektor v18=new Vektor(30,20,20);
        Vektor v19=new Vektor(30,30,20);
        Vektor v20=new Vektor(20,30,20);
        Quad q5=new Quad(Color.blue,Color.black,v17,v18,v19,v20);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        return g;
    }
    public static Group getFahne(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.yellow,Color.yellow,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,25);
        Vektor v16=new Vektor(5,5,25);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,25);
        Vektor v20=new Vektor(5,45,25);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,25);
        Vektor v24=new Vektor(45,5,25);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getWahl(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(40,0,0);
        Vektor v3=new Vektor(40,40,0);
        Vektor v4=new Vektor(0,40,0);
        Quad q1=new Quad(Color.green,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.lightGray,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q1.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getFestArrow(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.green,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(20,5,0);
        Vektor v6=new Vektor(20,25,0);
        Vektor v7=new Vektor(5,25,0);
        Vektor v8=new Vektor(25,45,0);
        Vektor v9=new Vektor(45,25,0);
        Vektor v10=new Vektor(30,25,0);
        Vektor v11=new Vektor(30,5,0);
        Polygon p=new Polygon(Color.lightGray,Color.black);
        p.add(v5);
        p.add(v6);
        p.add(v7);
        p.add(v8);
        p.add(v9);
        p.add(v10);
        p.add(v11);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        p.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(p);
        return g;
    }
    public static Group getHardStone(){
        Vektor v1=new Vektor(5,5,40);
        Vektor v2=new Vektor(45,5,40);
        Vektor v3=new Vektor(45,45,40);
        Vektor v4=new Vektor(5,45,40);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,40);
        Vektor v6=new Vektor(40,10,40);
        Vektor v7=new Vektor(40,40,40);
        Vektor v8=new Vektor(10,40,40);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,40);
        Vektor v12=new Vektor(5,5,40);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,40);
        Vektor v16=new Vektor(5,5,40);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,40);
        Vektor v20=new Vektor(5,45,40);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,40);
        Vektor v24=new Vektor(45,5,40);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getKugel(){
        Vektor v1=new Vektor(25,25,25);
        Kugel kug=new Kugel(Color.blue,Color.blue,v1,20);
        Group g=new Group();
        g.add(kug);
        return g;
    }
}
class EngineXarrow3D2 extends JPanel{
    Thread t;
    ImageFrameXarrow3D2 imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -1598636588069629084L;
    public EngineXarrow3D2(){
        imf=new ImageFrameXarrow3D2();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
//    }
    public synchronized void paint(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameXarrow3D2 extends JFrame{
    Image img;
    private static final long serialVersionUID = -2968544383076894859L;
    public ImageFrameXarrow3D2(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
